# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.PropertyUnitTypes do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :UnitTypeGarageAttachedYN,
    :ListingKeyNumeric,
    :UnitTypeActualRent,
    :UnitTypeBathsTotal,
    :UnitTypeBedsTotal,
    :UnitTypeGarageSpaces,
    :UnitTypeKeyNumeric,
    :UnitTypeProForma,
    :UnitTypeTotalRent,
    :UnitTypeUnitsTotal,
    :ListingId,
    :ListingKey,
    :UnitTypeDescription,
    :UnitTypeKey,
    :UnitTypeType,
    :ModificationTimestamp,
    :Property
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :UnitTypeGarageAttachedYN => boolean() | nil,
    :ListingKeyNumeric => float() | nil,
    :UnitTypeActualRent => float() | nil,
    :UnitTypeBathsTotal => float() | nil,
    :UnitTypeBedsTotal => float() | nil,
    :UnitTypeGarageSpaces => float() | nil,
    :UnitTypeKeyNumeric => float() | nil,
    :UnitTypeProForma => float() | nil,
    :UnitTypeTotalRent => float() | nil,
    :UnitTypeUnitsTotal => float() | nil,
    :ListingId => String.t | nil,
    :ListingKey => String.t | nil,
    :UnitTypeDescription => String.t | nil,
    :UnitTypeKey => String.t | nil,
    :UnitTypeType => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :Property => FoyerAPI.Model.Property.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.PropertyUnitTypes do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:Property, :struct, FoyerAPI.Model.Property, options)
  end
end

